ERTS_INCLUDE_DIR = $(shell erl -noshell -s init stop -eval "io:format(\"~ts/erts-~ts/include/\", [code:root_dir(), erlang:system_info(version)]).")
ERL_INTERFACE_INCLUDE_DIR = $(shell erl -noshell -s init stop -eval "io:format(\"~ts\", [code:lib_dir(erl_interface, include)]).")
ERL_INTERFACE_LIB_DIR ?= $(shell erl -noshell -s init stop -eval "io:format(\"~ts\", [code:lib_dir(erl_interface, lib)]).")

INCDIRS :=	-I $(ERTS_INCLUDE_DIR) -I $(ERL_INTERFACE_INCLUDE_DIR)

LDFLAGS :=	-L $(ERL_INTERFACE_LIB_DIR)

LDLIBS =	-lei -lerl_interface

CFLAGS :=	$(INCDIRS) -Wall -fPIC -MMD -g -c

CPPFLAGS =	-D_REENTRANT

NIF =		rtc.so

UNAME :=	$(shell uname)
ifeq ($(UNAME),Darwin)
	LDFLAGS :=	$(LDFLAGS) \
			-macosx_version_min $(shell sw_vers -productVersion) \
			-bundle -flat_namespace -undefined suppress
endif
ifeq ($(UNAME),Linux)
	LD =		gcc
	LDFLAGS :=	$(LDFLAGS) -shared -rdynamic
endif
ifeq ($(UNAME),SunOS)
	LDFLAGS :=	$(LDFLAGS) -G
endif

OBJS =	rtc.o

all:	$(NIF)

%.o: %.c
	$(CC) $(CFLAGS) $(CPPFLAGS) $< -o $@

$(NIF): $(OBJS)
	@$(LD) $(OBJS) $(LDFLAGS) $(LDLIBS) -o $@

clean:
	rm -fr $(OBJS) $(NIF)
